standard-build/backup/backup-script.sh

69 lines
2.1 KiB
Bash
Raw Normal View History

2022-12-19 17:41:03 +00:00
#!/bin/sh
2022-12-19 18:22:32 +00:00
. /etc/backup.conf
2022-12-19 17:41:03 +00:00
# some helpers and error handling:
info() { printf "\n%s %s\n\n" "$( date )" "$*" >&2; }
trap 'echo $( date ) Backup interrupted >&2; exit 2' INT TERM
info "Starting backup"
# Backup the most important directories into an archive named after
# the machine this script is currently running on:
2022-12-19 18:28:20 +00:00
/usr/local/bin/borg-linux64 create \
2022-12-19 17:41:03 +00:00
--verbose \
--filter AME \
--list \
--stats \
--show-rc \
--compression lz4 \
--exclude-caches \
2023-04-14 21:19:39 +01:00
--exclude '*/mnt/' \
2022-12-19 17:41:03 +00:00
\
::'{hostname}-{now}' \
/opt \
backup_exit=$?
info "Pruning repository"
# Use the `prune` subcommand to maintain 7 daily, 4 weekly and 6 monthly
# archives of THIS machine. The '{hostname}-' prefix is very important to
# limit prune's operation to this machine's archives and not apply to
# other machines' archives also:
2022-12-19 18:30:52 +00:00
/usr/local/bin/borg-linux64 prune \
2022-12-19 17:41:03 +00:00
--list \
--prefix '{hostname}-' \
--show-rc \
--keep-daily 7 \
--keep-weekly 4 \
--keep-monthly 6 \
prune_exit=$?
# actually free repo disk space by compacting segments
info "Compacting repository"
2022-12-19 18:28:20 +00:00
/usr/local/bin/borg-linux64 compact
2022-12-19 17:41:03 +00:00
compact_exit=$?
# use highest exit code as global exit code
global_exit=$(( backup_exit > prune_exit ? backup_exit : prune_exit ))
global_exit=$(( compact_exit > global_exit ? compact_exit : global_exit ))
if [ ${global_exit} -eq 0 ]; then
info "Backup, Prune, and Compact finished successfully"
if [ ! -z "$HEALTHCHECK_URL" ]; then
curl -L $HEALTHCHECK_URL
fi
2022-12-19 17:41:03 +00:00
elif [ ${global_exit} -eq 1 ]; then
info "Backup, Prune, and/or Compact finished with warnings"
else
info "Backup, Prune, and/or Compact finished with errors"
fi
exit ${global_exit}